local BS = AceLibrary("Babble-Spell-2.2");

--Compiled:
--Dots get no basedamage bonus
--Spells with sHits usually get no bonus: Exceptions: Hellfire
--Channeled spells usually get no bonus: Exceptions: Hellfire, Rain of Fire
--Drain Soul and Life Tap don't downrank. Lightning Shield, Healing Stream Totem, Magma Totem, Searing Totem, Earth Shield don't downrank.

DrDamageWarlockTable = {

	spellInfo = {
		[BS["Corruption"]] = {
					[0] = { School = "Shadow", castTime = 2, eDot = true, eDuration = 18, sTicks = 3, },
					[3] = { 222, 222, spellLevel = 24, maxLevel = 31, },
					[4] = { 324, 324, spellLevel = 34, maxLevel = 41, },
					[5] = { 486, 486, spellLevel = 44, sFactor = 1.154, }, --maxLevel = 51, }, --This rank doesn't seem to obey anything
					[6] = { 666, 666, spellLevel = 54, maxLevel = 57, },
					[7] = { 822, 822, spellLevel = 60, maxLevel = 62, },
					[8] = { 906, 906, spellLevel = 65, maxLevel = 70, },
					--What's the downranking logic here? Seems like -2
					--WTH is rank 5? Almost equal to rank 6.
		},
		[BS["Shadow Bolt"]] = {
					[0] = { School = "Shadow", castTime = 3, canCrit = true, CastMod = 0.1, coeffA = 1, coeffB = -1, diff = 8, },
					[4] = { 86, 98, spellLevel = 20, maxLevel = 27, },
					[5] = { 142, 162, spellLevel = 28, maxLevel = 35, },
					[6] = { 204, 230, spellLevel = 36, maxLevel = 43, },
					[7] = { 281, 315, spellLevel = 44, maxLevel = 51, },
					[8] = { 360, 402, spellLevel = 52, maxLevel = 59, }, 
					[9] = { 455, 507, spellLevel = 60, maxLevel = 60, },
					[10] ={ 482, 538, spellLevel = 60, maxLevel = 68, },
					[11] ={ 541, 603, spellLevel = 69, maxLevel = 70, },
		},
		[BS["Life Tap"]] = {
					[0] = { School = "Shadow", bonusFactor = 0.8, NoDPS = true, NoTooltip = true, NoBuffs = true, NoDebuffs = true, Unresistable = true, },
					[1] = { 30, 30, spellLevel = 6, }, 	--20
					[2] = { 75, 75, spellLevel = 16, }, 	--65
					[3] = { 140, 140, }, 			--130
					[4] = { 220, 220, }, 			--210
					[5] = { 310, 310, }, 			--300
					[6] = { 424, 424, }, 			--420
					[7] = { 580, 580, },
		},
		[BS["Curse of Agony"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 24, },
					[3] = { 324, 324, spellLevel = 28, maxLevel = 37, },
					[4] = { 504, 504, spellLevel = 38, maxLevel = 47, },
					[5] = { 780, 780, spellLevel = 48, maxLevel = 57, },
					[6] = { 1044, 1044, spellLevel = 58, maxLevel = 66, },
					[7] = { 1356, 1356, spellLevel = 67, maxLevel = 70, },
					--TODO: find out downranking
		},
		[BS["Curse of Doom"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 60, },
					["None"] = { 3200, 3200, spellLevel = 60 },
					[1] = { 3200, 3200, spellLevel = 60, },
					[2] = { 4200, 4200, spellLevel = 70, },
		},
		[BS["Death Coil"]] = {
					[0] = { School = "Shadow", sFactor = 0.5, Cooldown = 120, NoDoom = true, coeffA = 8, coeffB = 5, diff = 8, },
					[1] = { 244, 244, spellLevel = 42, maxLevel = 50, },
					[2] = { 319, 319, spellLevel = 50, maxLevel = 58, }, 
					[3] = { 400, 400, spellLevel = 58, maxLevel = 67, },
					[4] = { 519, 519, spellLevel = 68, maxLevel = 70, },
					--Note: Downrank: +1
		},
		[BS["Drain Life"]] = {
					[0] = { School = "Shadow", castTime=5, sHits = 5, sFactor = 0.5, },
					[2] = { 17, 17, spellLevel = 22, maxLevel = 29, },
					[5] = { 55, 55, spellLevel = 46, maxLevel = 53, },
					[6] = { 71, 71, spellLevel = 54, maxLevel = 61, },
					[7] = { 87, 87, spellLevel = 62, maxLevel = 68, },
					[8] = { 108, 108, spellLevel = 69, maxLevel = 70, },
					--Downranks normally
		},
		[BS["Drain Soul"]] = { 
					[0] = { School = "Shadow", castTime=15, sFactor = 0.5, sTicks = 3, },
					[2] = { 155, 155, spellLevel = 24, },
					[3] = { 295, 295, spellLevel = 38, },
					[4] = { 455, 455, spellLevel = 52, },
					[5] = { 620, 620, spellLevel = 67, }, 
					--No downranking
		},
		[BS["Siphon Life"]] = {
					[0] = { School = "Shadow", sHits = 10, eDot = true, eDuration = 30, sFactor = 0.5, },
					[1] = { 15, 15, spellLevel = 30, maxLevel = 40, },
					[2] = { 22, 22, spellLevel = 38, maxLevel = 50, },
					[3] = { 33, 33, spellLevel = 48, maxLevel = 60, },
					[4] = { 45, 45, spellLevel = 58, maxLevel = 65, },
					[5] = { 52, 52, spellLevel = 63, maxLevel = 70, },
					[6] = { 63, 63, spellLevel = 70, maxLevel = 70, },
					--Downrank seems to be +3, why?
		},
		[BS["Searing Pain"]] = { 
					[0] = { School = "Fire", canCrit = true, coeffA = 15, coeffB = 11, diff = 8, },
					[4] = { 122, 146, spellLevel = 42, maxLevel = 49, },
					[5] = { 158, 188, spellLevel = 50, maxLevel = 57, },
					[6] = { 204, 240, spellLevel = 58, maxLevel = 64, },
					[7] = { 243, 287, spellLevel = 65, maxLevel = 69, },
					[8] = { 270, 320, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Soul Fire"]] = {
					[0] = { School = "Fire", castTime=6, canCrit = true, CastMod = 0.4, coeffA = 20, coeffB = 18, diff = 8, },
					[1] = { 623, 783, spellLevel = 48, maxLevel = 55, },
					[2] = { 703, 881, spellLevel = 56, maxLevel = 63, }, 	
					[3] = { 839, 1051, spellLevel = 64, maxLevel = 69, },
					[4] = { 1003, 1257, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Shadowburn"]] = {
					[0] = { School = "Shadow", canCrit = true, coeffA = 0, coeffB = -2, diff = 8, },
					[5] = { 350, 392, spellLevel = 48, maxLevel = 55, },
					[6] = { 450, 502, spellLevel = 56, maxLevel = 62, },
					[7] = { 518, 578, spellLevel = 63, maxLevel = 69, },
					[8] = { 597, 665, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Immolate"]] = {
					[0] = { School = "Fire", canCrit = true, castTime=2, CastMod = 0.1, hybridFactor = 0.349, eDuration = 15, sTicks = 3, coeffA = 8, coeffB = 3, diff = 10, },
					[1] = { 8, 8, hybridDotDmg = 20, spellLevel = 1, maxLevel = 7, },
					[2] = {	19, 19, hybridDotDmg = 40, spellLevel = 10, maxLevel = 17, }, 	 
					[3] = { 45, 45, hybridDotDmg = 90, spellLevel = 20, maxLevel = 27, },	 
					[4] = { 90, 90, hybridDotDmg = 165, spellLevel = 30, maxLevel = 37, }, 
					[5] = { 134, 134, hybridDotDmg = 255, spellLevel = 40, maxLevel = 47, },
					[6] = { 192, 192, hybridDotDmg = 365, spellLevel = 50, maxLevel = 57, }, 
					[7] = { 258, 258, hybridDotDmg = 485, spellLevel = 60, maxLevel = 60, },
					[8] = { 279, 279, hybridDotDmg = 510, spellLevel = 60, maxLevel = 68, },
					[9] = { 327, 327, hybridDotDmg = 615, spellLevel = 69, maxLevel = 70, },
					--Note: Downrank -2.. reason = hybrid spell?
		},
		[BS["Hellfire"]] = {
					[0] = { School = "Fire", castTime=15, sHits = 15, sFactor = 1/3, coeffA = 4, coeffB = 2, diff = 12, },
					[2] = { 139, 139, spellLevel = 42, maxLevel = 54, },
					[3] = { 208, 208, spellLevel = 54, maxLevel = 67, }, 
					[4] = { 306, 306, spellLevel = 68, maxLevel = 70, },
					--Note: Downrank +1
		},
		[BS["Rain of Fire"]] = { 
					[0] = { School = "Fire", castTime=8, sFactor = 1/3, sTicks = 2, coeffA = 21, coeffB = 20, diff = 12, },
					[2] = { 384, 384, spellLevel = 34, maxLevel = 45, },
					[3] = { 620, 622, spellLevel = 46, maxLevel = 57, },
					[4] = { 904, 906, spellLevel = 58, maxLevel = 68, },
					[5] = { 1212, 1212, spellLevel = 69, maxLevel = 70, },
		},
		[BS["Unstable Affliction"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 18, sTicks = 3, },
					[1] = { 660, 660, spellLevel = 50, maxLevel = 59, },
					[2] = { 840, 840, spellLevel = 60, maxLevel = 69, },
					[3] = { 1050, 1050, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Conflagrate"]] = { 
					[0] = { School = "Fire", canCrit = true, coeffA = 8, coeffB = 6, diff = 6, },
					[1] = { 240, 306, spellLevel = 40, maxLevel = 47, },
					[2] = { 316, 396, spellLevel = 48, maxLevel = 53, },
					[3] = { 383, 479, spellLevel = 54, maxLevel = 59, },
					[4] = { 447, 557, spellLevel = 60, maxLevel = 64, },
					[5] = { 512, 638, spellLevel = 65, maxLevel = 69, },
					[6] = { 579, 721, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Seed of Corruption"]] = { 
					[0] = { School = "Shadow", canCrit = true, sFactor = 1/3, eDuration = 18, hybridDotFactor = 3, },
					[1] = { 1110, 1290, hybridDotDmg=1044, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Shadowfury"]] = { 
					[0] = { School = "Shadow", canCrit = true, sFactor = 1/3 * 0.95, coeffA = 27, coeffB = 24, diff = 10, },
					[1] = { 343, 407, spellLevel = 50, maxLevel = 59, },
					[2] = { 459, 547, spellLevel = 60, maxLevel = 69, },
					[3] = { 612, 728, spellLevel = 70, maxLevel = 70, },
		},				
	},	

 	talentInfo = {
 		--Affliction:
 		["Suppression"] = { Effect = 2, Spells = { "Corruption", "Curse of Agony", "Unstable Affliction", "Drain Life", "Drain Soul", "Seed of Corruption", "Siphon Life", "Death Coil", }, ModType ="Hit", },
		["Improved Corruption"] = { Effect = 0.04, Spells = { "Corruption" }, ModType = "CastTime" }, 	
		["Improved Life Tap"] = { Effect = 0.10, Spells = { "Life Tap" }, },		
		["Improved Curse of Agony"] = { Effect = 0.05, Spells = { "Curse of Agony" }, },
		["Empowered Corruption"] = { Effect = 0.12, Spells = { "Corruption" }, ModType = "SpellDamage" },
		["Shadow Mastery"] = { Effect = 0.02, Spells = { "Unstable Affliction", "Siphon Life", "Drain Life", "Drain Soul", "Shadowburn", "Shadow Bolt", "Corruption", "Curse of Agony", "Death Coil" }, },	
		["Contagion"] = { Effect = 0.01, Spells = { "Curse of Agony", "Corruption", "Seed of Corruption" }, },
		--Destruction:
		["Emberstorm"] = { Effect = 0.02, Spells = { "Searing Pain", "Immolate", "Soul Fire", "Hellfire", "Rain of Fire", "Incinerate", "Conflagrate" }, },
		["Improved Immolate"] = { Effect = 0.05, Spells = { "Immolate" }, ModType = "BaseNuke" },
		["Shadow and Flame"] = { Effect = 0.04, Spells = { "Shadow Bolt", "Incinerate" }, ModType = "SpellDamage" },
		["Bane"] = { Effect = 1, Spells = { "Shadow Bolt", "Immolate", "Soul Fire" }, ModType = "CastTime" },
		["Devastation"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", },
		["Backlash"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", },
		["Improved Searing Pain"] = { Effect = 10/3, Spells = { "Searing Pain" }, ModType = "Crit", },
		["Ruin"] = { Effect = 0.5, Spells = { "All" }, ModType = "CritMultiplier", },
		--["Improved Shadow Bolt"] = { Effect = 0.05, Spells = { "Shadow Bolt" }, ModType = "Special" }
		--Demonology:		
		["Demonic Tactics"] = { Effect = 0.01, Spells = { "All" }, },
		["Master Demonologist"] = { Effect = 1, Spells = { "All" }, ModType = "MD" },
	},
}

DrDamageMageTable = {

	spellInfo = { 
		[BS["Pyroblast"]] = {
					--Verify factor
					[0] = { School = "Fire", castTime=6, canCrit = true, Ignite = true, eDuration=12, sTicks = 3, bonusFactor = 1.15, hybridDotFactor = 0.25, },
					[5] = { 407, 515, hybridDotDmg=156, spellLevel = 42, maxLevel = 47, },
					[6] = { 503, 631, hybridDotDmg=188, spellLevel = 48, maxLevel = 53, },
					[7] = { 600, 750, hybridDotDmg=228, spellLevel = 54, maxLevel = 59, },
					[8] = { 708, 898, hybridDotDmg=268, spellLevel = 60, maxLevel = 65, },
					[9] = { 846, 1074, hybridDotDmg=312, spellLevel = 66, maxLevel = 69, },
					[10] = { 939, 1191, hybridDotDmg=356, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Fireball"]] = {
					[0] = { School = "Fire", canCrit = true, castTime=3.5, extraDotF = 0.02, CastMod = 0.1, Ignite = true, eDuration=8, sTicks = 2, },
					[8] = { 318, 414, extraDotDmg=40, spellLevel = 42, maxLevel = 47, },
					[9] = { 392, 506, extraDotDmg=52, spellLevel = 48, maxLevel = 53, },
					[10] = { 475, 609, extraDotDmg=60, spellLevel = 54, maxLevel = 59, },
					[11] = { 561, 715, extraDotDmg=72, spellLevel = 60, maxLevel = 60, },
					[12] = { 596, 760, extraDotDmg=76, spellLevel = 60, maxLevel = 65, },
					[13] = { 633, 805, extraDotDmg=84, spellLevel = 66, maxLevel = 70, },
		},
		[BS["Scorch"]] = {
					[0] = { School = "Fire", canCrit = true,  Ignite = true, },
					[4] = { 133, 159, spellLevel = 40, maxLevel = 45, },
					[5] = { 162, 192, spellLevel = 46, maxLevel = 51, },
					[6] = { 200, 239, spellLevel = 52, maxLevel = 57, },
					[7] = { 233, 275, spellLevel = 58, maxLevel = 63, },
					[8] = { 269, 317, spellLevel = 64, maxLevel = 69, },
					[9] = { 305, 361, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Fire Blast"]] = {
					[0] = { School = "Fire", canCrit = true, Ignite = true, Cooldown = 8 },
					[5] = { 242, 290, spellLevel = 38, maxLevel = 45, },
					[6] = { 332, 394, spellLevel = 46, maxLevel = 53, },
					[7] = { 431, 509, spellLevel = 54, maxLevel = 60, },
					[8] = { 539, 637, spellLevel = 61, maxLevel = 69, },
					[9] = { 664, 786, spellLevel = 70, maxLevel = 70, },
		},				
		[BS["Blast Wave"]] = {
					--VERIFY FACTOR
					[0] = { School = "Fire", canCrit = true, sFactor=0.95 * 1/3, Ignite = true, Cooldown = 45 },
					[3] = { 277, 329, spellLevel = 44, maxLevel = 51, },
					[4] = { 365, 433, spellLevel = 52, maxLevel = 59, },
					[5] = { 462, 544, spellLevel = 60, maxLevel = 64, },
					[6] = { 533, 627, spellLevel = 65, maxLevel = 69, },
					[7] = { 616, 724, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Dragon's Breath"]] = {
					[0] = { School = "Fire", canCrit = true, sFactor=0.95 * 1/3, Ignite = true, Cooldown = 20 },
					[1] = { 370, 430, spellLevel = 50, maxLevel = 55, },
					[2] = { 454, 526, spellLevel = 56, maxLevel = 63, },
					[3] = { 574, 666, spellLevel = 64, maxLevel = 69, },
					[4] = { 680, 790, spellLevel = 70, maxLevel = 70, },
		},				
		[BS["Flamestrike"]] = {
					--Verify
					[0] = { School = "Fire", castTime=3, canCrit = true, Ignite = true, eDuration=8, sTicks = 2, sFactor = 1/3 * 0.95, hybridFactor = 0.7 },
					[4] = { 220, 272, hybridDotDmg=192, spellLevel = 40, maxLevel = 47, },
					[5] = { 291, 359, hybridDotDmg=264, spellLevel = 48, maxLevel = 55, },
					[6] = { 375, 459, hybridDotDmg=340, spellLevel = 56, maxLevel = 63, },
					[7] = { 471, 575, hybridDotDmg=424, spellLevel = 64, maxLevel = 70, },
		},				
		[BS["Frostbolt"]] = {
					[0] = { School = "Frost", castTime=3, canCrit = true, CastMod = 0.1, sFactor=0.95, },
					[8] = { 292, 316, spellLevel = 44, maxLevel = 49, },
					[9] = { 353, 383, spellLevel = 50, maxLevel = 55, },
					[10] = { 429, 463, spellLevel = 56, maxLevel = 69, },
					[11] = { 515, 555, spellLevel = 60, maxLevel = 61, },
					[12] = { 522, 562, spellLevel = 62, maxLevel = 67, },
					[13] = { 597, 643, spellLevel = 68, maxLevel = 70, },
		},
		[BS["Blizzard"]] = {
					[0] = { School = "Frost", castTime=8, sFactor= 1/3, },
					[4] = { 720, 720, spellLevel = 44, maxLevel = 51, },
					[5] = { 936, 936, spellLevel = 52, maxLevel = 59, },
					[6] = { 1192, 1192, spellLevel = 60, maxLevel = 67, },
					[7] = { 1472, 1472, spellLevel = 68, maxLevel = 70, },
		},
		[BS["Cone of Cold"]] = {
					--VERIFY FACTOR
					[0] = { School = "Frost", canCrit = true, sFactor= 0.95 * 1/3, Cooldown = 10 },
					[3] = { 203, 223, spellLevel = 42, maxLevel = 49, },
					[4] = { 264, 290, spellLevel = 50, maxLevel = 57, },
					[5] = { 335, 365, spellLevel = 58, maxLevel = 65, },
					[6] = { 410, 448, spellLevel = 66, maxLevel = 70, },
		},
		[BS["Frost Nova"]] = {
					[0] = { School = "Frost", canCrit = true, sFactor= 0.2 * 1/3, Cooldown = 25 },
					[1] = { 19, 21,  spellLevel = 10, maxLevel = 25, },
					[2] = { 33, 37, spellLevel = 26, maxLevel = 39, },
					[3] = { 47, 53, spellLevel = 40, maxLevel = 53, },
					[4] = { 71, 79, spellLevel = 54, maxLevel = 67, },
					[5] = { 99, 111, spellLevel = 68, maxLevel = 70, },
		},				
		[BS["Arcane Missiles"]] = {
					[0] = { School = "Arcane", canCrit = true, castTime=5, sHits=5, },
					[5] = { 115, 115, spellLevel = 40, maxLevel = 47, },
					[6] = { 151, 151, spellLevel = 48, maxLevel = 55, },
					[7] = { 192, 192, spellLevel = 56, maxLevel = 59, },
					[8] = { 230, 230, spellLevel = 60, maxLevel = 63, },
					[9] = { 240, 240, spellLevel = 64, maxLevel = 70, },
		},
		[BS["Arcane Explosion"]] = {
					[0] = { School = "Arcane", canCrit = true, sFactor=1/3, },
					[1] = { 32, 36,  spellLevel = 14, maxLevel = 21, },
					[5] = { 186, 202, spellLevel = 46, maxLevel = 53, },
					[6] = { 243, 263, spellLevel = 54, maxLevel = 61, },
					[7] = { 306, 330, spellLevel = 62, maxLevel = 69, },
					[8] = { 377, 407, spellLevel = 70, maxLevel = 70, },
		},
	},
			
	talentInfo = { 
		--ARCANE:
		["Arcane Focus"] = { Effect = 2, Spells = { "Arcane Explosion", "Arcane Blast", "Arcane Missiles" }, ModType = "Hit", },
		["Arcane Impact"] = { Effect = 2, Spells = { "Arcane Explosion", "Arcane Blast" }, ModType = "Crit", },
		["Arcane Instability"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", Effect2 = 0.01, Spells2 = { "All" }, ModType2 ="SpellDamage", Multiply2 = true, },
		["Spell Power"] = { Effect = 0.125, Spells = { "All" }, ModType = "CritMultiplier", },
		["Empowered Arcane Missiles"] = { Effect = 0.15, Spells = { "Arcane Missiles" }, ModType = "SpellDamage", Multiply = true },
		--FIRE:
		["Improved Fireball"] = { Effect = 1, Spells = { "Fireball" }, ModType = "CastTime" },
		["Ignite"] = { Effect = 0.08, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Ignite", },
		["Incinerate"] = { Effect = 2, Spells = { "Fire Blast", "Scorch", }, ModType = "Crit", },
		["Improved Flamestrike"] = { Effect = 5, Spells = { "Flamestrike" }, ModType = "Crit", },
		["Critical Mass"] = { Effect = 2, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Crit", },
		["Playing with Fire"] = { Effect = 0.01, Spells = { "All" }, Multiply = true, },
		["Fire Power"] = { Effect = 0.02, Spells = { "Fireball", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike", "Pyroblast", }, Multiply = true, },
		["Pyromaniac"] = { Effect = 1, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Crit", },
		["Empowered Fireball"] = { Effect = 0.03, Spells = { "Fireball" }, ModType = "SpellDamage", Multiply = true, },
		["Improved Fire Blast"] = { Effect = 0.5, Spells = { "Fire Blast" }, ModType = "Cooldown", },
		--FROST:
		["Elemental Precision"] = { Effect = 1, Spells = { "Frostbolt", "Cone of Cold", "Frost Nova", "Blizzard", "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Hit" },
		["Improved Frostbolt"] = { Effect = 1, Spells = { "Frostbolt" }, ModType = "CastTime" },
		["Ice Shards"] = { Effect = 0.10, Spells = { "Frostbolt", "Cone of Cold", "Frost Nova" }, ModType = "CritMultiplier", },
		["Piercing Ice"] = { Effect = 0.02, Spells = { "Frostbolt", "Cone of Cold", "Blizzard", "Frost Nova", }, Multiply = true },
		["Improved Cone of Cold"] = { Effect = 35/300, Spells = { "Cone of Cold" }, Multiply = true, },
		["Empowered Frostbolt"] = { Effect = 0.02, Spells = { "Frostbolt" }, ModType = "SpellDamage", Multiply = true, Effect2 = 1, Spells2 = { "Frostbolt" }, ModType2 = "Crit" }, 
	},
}

DrDamagePriestTable = {

	spellInfo = { 
		[BS["Mind Flay"]] = {
					[0] = { School = "Shadow", castTime=3, sFactor = 0.665, sTicks = 1, },
					[3] = { 186, 186, spellLevel = 36, maxLevel = 43, },
					[4] = { 261, 261, spellLevel = 44, maxLevel = 51, },
					[5] = { 330, 330, spellLevel = 52, maxLevel = 59, },
					[6] = { 426, 426, spellLevel = 60, maxLevel = 67, },
					[7] = { 528, 528, spellLevel = 68, maxLevel = 70, },
		},		
		[BS["Devouring Plague"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 24, sFactor = 0.5, Cooldown = 180, sTicks = 3, },
					[3] = { 400, 400, spellLevel = 36, maxLevel = 43, },
					[4] = { 544, 544, spellLevel = 44, maxLevel = 51, },
					[5] = { 712, 712, spellLevel = 52, maxLevel = 59, },
					[6] = { 904, 904, spellLevel = 60, maxLevel = 67, },
					[7] = { 1216, 1216, spellLevel = 68, maxLevel = 70, },
		},
		[BS["Shadow Word: Pain"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 18, sTicks = 3, },
					[5] = { 366, 366, spellLevel = 34, maxLevel = 41, },
					[6] = { 510, 510, spellLevel = 42, maxLevel = 49, },	
					[7] = { 672, 672, spellLevel = 50, maxLevel = 57, },
					[8] = { 852, 852, spellLevel = 58, maxLevel = 64, },
					[9] = { 1002, 1002, spellLevel = 65, maxLevel = 70, },		
		},
		[BS["Vampiric Touch"]] = {
					[0] = { School = "Shadow", eDot = true, eDuration = 15, sTicks = 3, },
					[1] = { 450, 450, spellLevel = 50, maxLevel = 59, },
					[2] = { 600, 600, spellLevel = 60, maxLevel = 69, },	
					[3] = { 650, 650, spellLevel = 70, maxLevel = 70, },	
		},		
		[BS["Shadow Word: Death"]] = {
					[0] = { School = "Shadow", canCrit = true, Cooldown = 6, },
					[1] = { 450, 522, spellLevel = 62, maxLevel = 69, },
					[2] = { 572, 664, spellLevel = 70, maxLevel = 70, },				
		},		
		[BS["Mind Blast"]] = {
					[0] = { School = "Shadow", canCrit = true, Cooldown = 8 },
					[5] = { 217, 231, spellLevel = 34, maxLevel = 39, },
					[6] = { 279, 297, spellLevel = 40, maxLevel = 45, },
					[7] = { 346, 366, spellLevel = 46, maxLevel = 51, },
					[8] = { 425, 449, spellLevel = 52, maxLevel = 57, },
					[9] = { 503, 531, spellLevel = 58, maxLevel = 62, },
					[10] = { 557, 587, spellLevel = 63, maxLevel = 68, },
					[11] = { 708, 748, spellLevel = 69, maxLevel = 70, },
		},
		[BS["Power Word: Shield"]] = {
					[0] = { School = "Holy", Healing = true, bonusFactor = 0.1, Cooldown = 4, NoDPS = true, NoDebuffs = true, NoDoom = true, },
					[7] = { 484, 484, spellLevel = 42, maxLevel = 47, },
					[8] = { 605, 605, spellLevel = 48, maxLevel = 53, },
					[9] = { 763, 763, spellLevel = 54, maxLevel = 59, },
					[10] = { 942, 942, spellLevel = 60, maxLevel = 64, },
					[11] = { 1147, 1147, spellLevel = 65, maxLevel = 69, },
					[12] = { 1315, 1315, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Heal"]] = {
					[0] = { School = "Holy", canCrit = true, Healing = true, castTime = 3, CastMod = 0.1 },
					[1] = { 295, 341, spellLevel = 16, maxLevel = 21, },
					[2] = { 429, 491, spellLevel = 22, maxLevel = 27, },
					[3] = { 566, 642, spellLevel = 28, maxLevel = 33, },
					[4] = { 712, 804, spellLevel = 34, maxLevel = 39, },				
		},		
		[BS["Greater Heal"]] = {
					[0] = { School = "Holy", canCrit = true, Healing = true, castTime = 3, CastMod = 0.1 },
					[1] = { 899, 1013, spellLevel = 40, maxLevel = 45, },
					[2] = { 1149, 1289, spellLevel = 46, maxLevel = 51, },
					[3] = { 1437, 1609, spellLevel = 52, maxLevel = 57, },
					[4] = { 1798, 2006, spellLevel = 58, maxLevel = 59, },
					[5] = { 1966, 2194, spellLevel = 60, maxLevel = 62, },
					[6] = { 2074, 2410, spellLevel = 63, maxLevel = 67, },
					[7] = { 2396, 2784, spellLevel = 68, maxLevel = 70, },					
		},
		[BS["Prayer of Healing"]] = {
					[0] = { School = "Holy", canCrit = true, castTime = 3, Healing = true, sFactor = 1/3 },
					[2] = { 444, 472, spellLevel = 40, maxLevel = 49, },
					[3] = { 657, 695, spellLevel = 50, maxLevel = 59, },
					[4] = { 939, 991, spellLevel = 60, maxLevel = 60, },
					[5] = { 1041, 1099, spellLevel = 60, maxLevel = 67, },
					[6] = { 1246, 1316, spellLevel = 68, maxLevel = 70, },
		},
		[BS["Circle of Healing"]] = {
					[0] = { School = "Holy", Healing = true, sFactor = 1/3 },
					[1] = { 289, 319, spellLevel = 50, maxLevel = 55, },
					[2] = { 337, 372, spellLevel = 56, maxLevel = 59, },
					[3] = { 385, 426, spellLevel = 60, maxLevel = 64, },
					[4] = { 434, 479, spellLevel = 65, maxLevel = 69, },
					[5] = { 475, 525, spellLevel = 70, maxLevel = 70, },
		},		
		[BS["Flash Heal"]] = {
					[0] = { School = "Holy", canCrit = true, Healing = true, },
					[4] = { 400, 478, spellLevel = 38, maxLevel = 43, },
					[5] = { 518, 616, spellLevel = 44, maxLevel = 51, },
					[6] = { 655, 764, spellLevel = 52, maxLevel = 57, },
					[7] = { 812, 958, spellLevel = 58, maxLevel = 60, },
					[8] = { 913, 1059, spellLevel = 61, maxLevel = 66, },
					[9] = { 1101, 1279, spellLevel = 67, maxLevel = 70, },
					--TC says: 25, 31, 37, 43, 49, 55, 60, 66
		},
		[BS["Desperate Prayer"]] = {
					[0] = { School = "Holy", canCrit = true, Healing = true, NoDoom = true, },
					[5] = { 834, 994, spellLevel = 42, maxLevel = 49, },
					[6] = { 1101, 1305, spellLevel = 50, maxLevel = 57, },
					[7] = { 1324, 1562, spellLevel = 58, maxLevel = 65, },
					[8] = { 1601, 1887, spellLevel = 66, maxLevel = 70, },
		},		
		[BS["Renew"]] = {
					[0] = { School = "Holy", eDot = true, eDuration = 15, Healing = true, sTicks = 3, },
					[7] = { 510, 510, spellLevel = 44, maxLevel = 49, },
					[8] = { 650, 650, spellLevel = 50, maxLevel = 55, },
					[9] = { 810, 810, spellLevel = 56, maxLevel = 59, },
					[10] = { 970, 970, spellLevel = 60, maxLevel = 64, },
					[11] = { 1010, 1010, spellLevel = 65, maxLevel = 69, },
					[12] = { 1110, 1110, spellLevel = 70, maxLevel = 70, },
		},		
		[BS["Smite"]] = {
					[0] = { School = "Holy", canCrit = true, castTime=2.5, CastMod = 0.1 },
					[5] = { 150, 170, spellLevel = 30, maxLevel = 37, },
					[6] = { 212, 240, spellLevel = 38, maxLevel = 45, },
					[7] = { 287, 323, spellLevel = 46, maxLevel = 53, },
					[8] = { 371, 415, spellLevel = 54, maxLevel = 60, },
					[9] = { 405, 453, spellLevel = 61, maxLevel = 68, },
					[10] = { 545, 611, spellLevel = 69, maxLevel = 70, },					
		},
		[BS["Holy Fire"]] = {
					[0] = { School = "Holy", canCrit = true, castTime=3.5, eDuration = 10, sTicks = 2, CastMod = 0.1, hybridFactor = 0.75 },
					[4] = { 165, 209, hybridDotDmg= 65, spellLevel = 36, maxLevel = 41, },
					[5] = { 204, 258, hybridDotDmg= 85, spellLevel = 42, maxLevel = 47, },
					[6] = { 254, 322, hybridDotDmg= 100, spellLevel = 48, maxLevel = 53, },
					[7] = { 304, 386, hybridDotDmg= 125, spellLevel = 54, maxLevel = 59, },
					[8] = { 355, 449, hybridDotDmg= 145, spellLevel = 60, maxLevel = 65, },
					[9] = { 412, 522, hybridDotDmg= 165, spellLevel = 66, maxLevel = 70, },					
		},
		[BS["Holy Nova"]] = {
					[0] = { School = "Holy", canCrit = true, sFactor = 1/3 * 0.8 }, --hFactor = 0.11
					[3] = { 76, 88, hMin=121, hMax=139, spellLevel = 36, maxLevel = 43, },
					[4] = { 106, 123, hMin=161, hMax=188, spellLevel = 44, maxLevel = 51, },
					[5] = { 140, 163, hMin=235, hMax=272, spellLevel = 52, maxLevel = 59, },
					[6] = { 181, 210, hMin=302, hMax=350, spellLevel = 60, maxLevel = 67, },
					[7] = { 242, 280, hMin=384, hMax=446, spellLevel = 68, maxLevel = 70, },
		},
		[BS["Starshards"]] = {
					[0] = { School = "Arcane", castTime = 6, },
					[4] = { 414, 414, spellLevel = 34, maxLevel = 41, },
					[5] = { 570, 570, spellLevel = 42, maxLevel = 49, },
					[6] = { 756, 756, spellLevel = 50, maxLevel = 57, },
					[7] = { 936, 936, spellLevel = 58, maxLevel = 65, },
					[8] = { 1128, 1128, spellLevel = 66, maxLevel = 70, },
		},				
	},

	talentInfo = { 
		--SHADOW:
		["Shadow Focus"] = { Effect = 2, Spells = { "Shadow Word: Pain", "Mind Blast", "Mind Flay", "Shadow Word: Death", "Devouring Plague" }, ModType = "Hit" },
		["Improved Shadow Word: Pain"] = { Effect = 3, Spells = { "Shadow Word: Pain" }, ModType = "SpellDuration", },
		["Darkness"] = { Effect = 0.02, Spells = { "Shadow Word: Pain", "Mind Blast", "Mind Flay", "Shadow Word: Death", "Devouring Plague" }, },
		["Focused Mind"] = { Effect = 3, Spells = { "Mind Blast", "Shadow Word: Death" }, ModType = "Crit", },
		["Improved Mind Blast"] = { Effect = 0.5, Spells = { "Mind Blast" }, ModType = "Cooldown" },
		--HOLY:
		["Holy Specialization"] = { Effect = 1, Spells = { "Smite", "Holy Fire", "Heal", "Greater Heal", "Flash Heal", "Holy Nova" }, ModType = "Crit", },
		["Improved Renew"] = { Effect = 0.05, Spells = { "Renew" }, Multiply = true, },
		["Divine Fury"] = { Effect = 1, Spells = { "Smite", "Holy Fire", "Heal", "Greater Heal" }, ModType = "CastTime", },
		["Searing Light"] = { Effect = 0.05, Spells = { "Smite", "Holy Fire" }, },
		["Spiritual Healing"] = { Effect = 0.02, Spells = { "Renew", "Heal", "Flash Heal", "Greater Heal", "Prayer of Healing", "Desperate Prayer", "Circle of Healing" }, Multiply = true, },
		["Empowered Healing"] = { Effect = 0.04, Spells = { "Greater Heal" }, ModType = "SpellDamage", Effect2 = 0.02, Spells2 = { "Flash Heal" }, ModType2 = "SpellDamage", },
		--DISCIPLINE:
		["Improved Power Word: Shield"] = { Effect = 0.05, Spells = { "Power Word: Shield" }, },
		["Force of Will"] = { Effect = 1, Spells = { "Smite", "Holy Fire", "Mind Blast", "Shadow Word: Death", }, ModType = "Crit", },
	},
}

DrDamageShamanTable = {

	spellInfo = {
		[BS["Lightning Shield"]] = {
						[0] = { School = "Nature", bonusFactor = 0.805, sHits = 3, NoDPS = true, NoDoom = true, },
						[5] = { 114, 114, spellLevel = 40, }, --maxLevel = 47, },
						[6] = { 154, 154, spellLevel = 48, }, --maxLevel = 55, },
						[7] = { 198, 198, spellLevel = 56, }, --maxLevel = 62, },
						[8] = { 232, 232, spellLevel = 63, }, --maxLevel = 69, },
						[9] = { 287, 287, spellLevel = 70, }, --maxLevel = 70, },
						--No downranking penalty
		},	
		[BS["Lightning Bolt"]] = {
						[0] = { School = "Nature", canCrit = true, castTime = 3, CastMod = 0.2, coeffA = 15, coeffB = 13, diff = 6, },
						[8] = { 282, 316, spellLevel = 44, maxLevel = 50, },
						[9] = { 347, 389, spellLevel = 50, maxLevel = 56, },
						[10] = { 419, 467, spellLevel = 56, maxLevel = 62, }, 
						[11] = { 495, 565, spellLevel = 62, maxLevel = 67, }, 
						[12] = { 563, 643, spellLevel = 67, maxLevel = 70, },
						--Downrank +1
		},
		[BS["Chain Lightning"]] = {
						[0] = { School = "Nature", canCrit = true, castTime = 2.5, CastMod = 0.2, Cooldown = 6, chainFactor = 0.7, coeffA = 6, coeffB = 4, diff = 8, },
						[1] = { 191, 217, spellLevel = 32, maxLevel = 39, },
						[2] = { 277, 311, spellLevel = 40, maxLevel = 47, },
						[3] = { 378, 424, spellLevel = 48, maxLevel = 55, },
						[4] = { 493, 551, spellLevel = 56, maxLevel = 62, },
						[5] = { 603, 687, spellLevel = 63, maxLevel = 69, },
						[6] = { 734, 838, spellLevel = 70, maxLevel = 70, },
						--Normal downranking
		},
		[BS["Earth Shock"]] = {
						[0] = { School = "Nature", canCrit = true, Cooldown = 6, sFactor = 0.90, coeffA = 3, coeffB = 1, diff = 12, },
						[1] = { 17, 19, spellLevel = 4, maxLevel = 9, },
						[2] = { 32, 34, spellLevel = 8, maxLevel = 15, },
						[3] = { 60, 64, spellLevel = 14, maxLevel = 21, },
						[4] = { 119, 127, spellLevel = 24, maxLevel = 33, },
						[5] = { 225, 239, spellLevel = 36, maxLevel = 45, },
						[6] = { 359, 381, spellLevel = 48, maxLevel = 57, }, 
						[7] = { 517, 545, spellLevel = 60, maxLevel = 67, },
						[8] = { 658, 692, spellLevel = 69, maxLevel = 70, },
						--NOTE: Downrank -2, ranks 1-2 behave odd
		},
		[BS["Flame Shock"]] = {
						[0] = { School = "Fire", canCrit = true, Cooldown = 6, eDuration = 12, sTicks = 3, sFactor = 0.5, hybridDotFactor = 0.4, coeffA = 11, coeffB = 7, diff = 9, },
						[2] = { 45, 45, hybridDotDmg = 49, spellLevel = 18, maxLevel = 24, },
						[3] = { 86, 86, hybridDotDmg = 96, spellLevel = 28, maxLevel = 36, },
						[4] = { 152, 152, hybridDotDmg = 168, spellLevel = 40, maxLevel = 48, },
						[5] = { 230, 230, hybridDotDmg = 256, spellLevel = 52, maxLevel = 56, },
						[6] = { 309, 309, hybridDotDmg = 344, spellLevel = 60, maxLevel = 67, },
						[7] = { 377, 377, hybridDotDmg = 420, spellLevel = 70, maxLevel = 70, },
						--NOTE: Downrank -3
		},
		[BS["Frost Shock"]] = {
						--Verify factor:
						[0] = { School = "Frost", canCrit = true, Cooldown = 6, sFactor = 0.90, coeffA = 3, coeffB = 1, diff = 12, },
						[3] = { 333, 353, spellLevel = 46, maxLevel = 54, },
						[4] = { 486, 514, spellLevel = 58, maxLevel = 64, },
						[5] = { 640, 676, spellLevel = 68, maxLevel = 70, },
						--Downrank: -3
		},		
		[BS["Searing Totem"]] = {
						--Verify factor: basic dot factor + 1/3 to compensate versus aoe totems
						
						[0] = { School = "Fire", sHits = 10, eDot = true, eDuration = 20, canCrit = true, bonusFactor = (20/15) + (1/3) },
						[2] = { 13, 17, spellLevel = 20, }, --maxLevel = 29, },
						[4] = { 26, 34, spellLevel = 40, }, --maxLevel = 49, },
						[5] = { 33, 45, spellLevel = 50, }, --maxLevel = 59, },
						[6] = { 40, 54, spellLevel = 60, }, --maxLevel = 68, },
						[7] = { 50, 66, spellLevel = 69, }, --maxLevel = 70, },
						--No downranking penalty
		},
		[BS["Fire Nova Totem"]] = {
						--verify factor
						[0] = { School = "Fire", canCrit = true, sFactor = 1/3, Cooldown = 15, coeffA = 16, coeffB = 13, diff = 10 },
						[1] = { 48, 56, spellLevel = 12, maxLevel = 21, },
						[2] = { 102, 116, spellLevel = 22, maxLevel = 31, },
						[3] = { 184, 208, spellLevel = 32, maxLevel = 41, },
						[4] = { 281, 317, spellLevel = 42, maxLevel = 51, },
						[5] = { 396, 442, spellLevel = 52, maxLevel = 60, },
						[6] = { 518, 578, spellLevel = 61, maxLevel = 69, },
						[7] = { 654, 730, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Magma Totem"]] = {
						[0] = { School = "Fire", canCrit = true, eDot = true, eDuration = 20, sHits = 10, sFactor = 1/3, },
						[1] = { 22, 22, spellLevel = 26, }, -- maxLevel = 35, },
						[2] = { 37, 37, spellLevel = 36, }, -- maxLevel = 45, },
						[3] = { 54, 54, spellLevel = 46, }, -- maxLevel = 55, },
						[4] = { 75, 75, spellLevel = 56, }, -- maxLevel = 66, },
						[5] = { 97, 97, spellLevel = 67, }, -- maxLevel = 70, },
						--No downranking penalty
		},		
		[BS["Lesser Healing Wave"]] = {
						[0] = { School = "Nature", canCrit = true, Healing = true, coeffA = 18, coeffB = 16, diff = 8, },
						[1] = { 162, 186, spellLevel = 20, maxLevel = 26, },
						[2] = { 247, 281, spellLevel = 28, maxLevel = 34, },
						[3] = { 337, 381, spellLevel = 36, maxLevel = 42, },
						[4] = { 458, 514, spellLevel = 44, maxLevel = 50, },
						[5] = { 631, 705, spellLevel = 52, maxLevel = 58, },
						[6] = { 832, 928, spellLevel = 60, maxLevel = 64, },
						[7] = { 1039, 1185, spellLevel = 66, maxLevel = 70, },
						--Downrank: -1
		},
		[BS["Healing Wave"]] = {
						[0] = { School = "Nature", canCrit = true, Healing = true, castTime = 3, CastMod = 0.1, coeffA = 42, coeffB = 40, diff = 8, },
						[5] = { 376, 440, spellLevel = 24, maxLevel = 29, },
						[6] = { 536, 622, spellLevel = 32, maxLevel = 37, },
						[7] = { 740, 854, spellLevel = 40, maxLevel = 45, },
						[8] = { 1017, 1167, spellLevel = 48, maxLevel = 53, },
						[9] = { 1367, 1561, spellLevel = 56, maxLevel = 60, },
						[10] = { 1620, 1850, spellLevel = 60, maxLevel = 60, },
						[11] = { 1725, 1969, spellLevel = 63, maxLevel = 67, },
						[12] = { 2134, 2436, spellLevel = 70, maxLevel = 70, },
						--Downrank: -2
		},
		[BS["Chain Heal"]] = {
						[0] = { School = "Nature", canCrit = true, castTime = 2.5, Healing = true, chainFactor = 0.5, coeffA = 13, coeffB = 11, diff = 8, },
						[1] = { 320, 368, spellLevel = 40, maxLevel = 45, },
						[2] = { 405, 465, spellLevel = 46, maxLevel = 52, }, --Rank 2: seems to recieve less +damage effects
						[3] = { 551, 629, spellLevel = 54, maxLevel = 60, },
						[4] = { 605, 691, spellLevel = 61, maxLevel = 67, },
						[5] = { 826, 942, spellLevel = 68, maxLevel = 70, },
						--Seems to downrank normally except for rank 2
		},
		[BS["Healing Stream Totem"]] = {
						[0] = { School = "Nature", eDot = true, eDuration = 60, Healing = true, sHits = 30, sFactor = 1/3, },
						[1] = { 6, 6, spellLevel = 20, }, --maxLevel = 29, },
						[2] = { 8, 8, spellLevel = 30, }, --maxLevel = 39, },
						[3] = { 10, 10, spellLevel = 40, }, --maxLevel = 49, },
						[4] = { 12, 12, spellLevel = 50, }, --maxLevel = 59, },
						[5] = { 14, 14, spellLevel = 60, }, --maxLevel = 68, },
						[6] = { 18, 18, spellLevel = 69, }, --maxLevel = 70, },
						--No downranking penalty. Seems to match perfectly.
		},
		[BS["Earth Shield"]] = {
						--Verify factor
						[0] = { School = "Nature", Healing = true, sHits = 10, bonusFactor = 2.82, NoDPS = true, NoDoom = true, NoDebuffs = true },
						[1] = { 150, 150, spellLevel = 50, }, --maxLevel = 59, },
						[2] = { 205, 205, spellLevel = 60, }, --maxLevel = 69, },
						[3] = { 270, 270, spellLevel = 70, }, --maxLevel = 70, },
						--Guessing no downranking penalty
		},		
	},
	talentInfo = { 
		["Concussion"] = { Effect = 0.01, Spells = { "Lightning Bolt", "Chain Lightning", "Earth Shock", "Frost Shock", "Flame Shock" }, },
		["Call of Flame"] = { Effect = 0.05, Spells = { "Searing Totem", "Magma Totem", "Fire Nova Totem" }, },
		["Call of Thunder"] = { Effect = 1, Spells = { "Lightning Bolt", "Chain Lightning" }, ModType = "Crit", },
		["Lightning Mastery"] = { Effect = 1, Spells = { "Lightning Bolt", "Chain Lightning" }, ModType = "CastTime", },
		["Elemental Fury"] = { Effect = 0.5, Spells = { "Searing Totem", "Magma Totem", "Fire Nova Totem", "Earth Shock", "Frost Shock", "Flame Shock", "Lightning Bolt", "Chain Lightning" }, ModType="CritMultiplier", },
		["Elemental Precision"] = { Effect = 1, Spells = { "Lightning Shield", "Searing Totem", "Magma Totem", "Fire Nova Totem", "Earth Shock", "Frost Shock", "Flame Shock", "Lightning Bolt", "Chain Lightning" }, ModType = "Hit", },
		["Improved Lightning Shield"] = { Effect = 0.05, Spells = { "Lightning Shield" }, },
		["Tidal Mastery"] = { Effect = 1, Spells = { "Lesser Healing Wave", "Healing Wave", "Chain Heal", "Lightning Bolt", "Chain Lightning" }, ModType = "Crit", },
		["Purification"] = { Effect = 0.02, Spells = { "Lesser Healing Wave", "Healing Wave", "Chain Heal", "Earth Shield", "Healing Stream Totem"  }, Multiply = true, },
		["Improved Chain Heal"] = { Effect = 0.10, Spells = { "Chain Heal"  }, Multiply = true, },
		["Improved Healing Wave"] = { Effect = 1, Spells = { "Healing Wave"  }, ModType = "CastTime" },
		["Restorative Totems"] = { Effect = 0.05, Spells = { "Healing Stream Totem" }, Multiply = true, },
		["Reverberation"] = { Effect = 0.2, Spells = { "Earth Shock", "Frost Shock", "Flame Shock" }, ModType = "Cooldown" },
	},
	
}

DrDamageDruidTable = {

	spellInfo = {
	
		[BS["Wrath"]] = {
					[0] = { School = "Nature", canCrit = true, castTime = 2, CastMod = 0.1 },
					[6] = { 139, 157, spellLevel = 38, maxLevel = 45, },
					[7] = { 188, 210, spellLevel = 46, maxLevel = 53, },
					[8] = { 236, 264, spellLevel = 54, maxLevel = 60, },
					[9] = { 278, 312, SpellLevel = 61, maxLevel = 68, },
					[10] = { 381, 429, SpellLevel = 69, maxLevel = 70, },
		},
		[BS["Hurricane"]] = {
					[0] = { School = "Nature", castTime = 10, sHits = 10, sFactor = 1/3  },
					[1] = { 70, 70, spellLevel = 40, maxLevel = 49, },
					[2] = { 100, 100, spellLevel = 50, maxLevel = 59, },
					[3] = { 134, 134, spellLevel = 60, maxLevel = 69, },
					[4] = { 206, 206, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Insect Swarm"]] = {
					[0] = { School = "Nature", eDot = true, eDuration = 12, },
					[3] = { 174, 174, spellLevel = 40, maxLevel = 49, },
					[4] = { 264, 264, spellLevel = 50, maxLevel = 59, },
					[5] = { 324, 324, spellLevel = 60, maxLevel = 69, },
					[6] = { 366, 366, spellLevel = 70, maxLevel = 70, },
		},		
		[BS["Moonfire"]] = {
					[0] = { School = "Arcane", canCrit = true, eDuration = 12, sTicks = 3, hybridFactor = 0.348 },
					[7] = { 105, 125, hybridDotDmg = 212, spellLevel = 40, maxLevel = 45, },
					[8] = { 130, 154, hybridDotDmg = 264, spellLevel = 46, maxLevel = 51, },
					[9] = { 157, 185, hybridDotDmg = 320, spellLevel = 52, maxLevel = 57, },
					[10] = { 189, 221, hybridDotDmg = 384, spellLevel = 58, maxLevel = 62, },
					[11] = { 200, 258, hybridDotDmg = 444, spellLevel = 63, maxLevel = 69, },
					[12] = { 305, 357, hybridDotDmg = 600, spellLevel = 70, maxLevel = 70, },
		},
		[BS["Starfire"]] = {
					[0] = { School = "Nature", canCrit = true, castTime = 3.5, CastMod = 0.1 },
					[4] = { 280, 334, spellLevel = 42, maxLevel = 49, },
					[5] = { 362, 428, spellLevel = 50, maxLevel = 57, },
					[6] = { 445, 525, spellLevel = 58, maxLevel = 66, }, --Verify maxlevel
					[7] = { 496, 584, spellLevel = 60, maxLevel = 66, },
					[8] = { 540, 636, spellLevel = 67, maxLevel = 70, },
		},
		[BS["Healing Touch"]] = {
					[0] = { School = "Nature", Healing = true, canCrit = true, castTime = 3.5, CastMod = 0.1 },
					[8] = { 1199, 1427, spellLevel = 44, maxLevel = 49, },
					[9] = { 1516, 1796, spellLevel = 50, maxLevel = 55, },
					[10] = { 1890, 2230, spellLevel = 56, maxLevel = 59, }, --Verify maxlevel
					[11] = { 2267, 2677, spellLevel = 60, maxLevel = 61, },
					[12] = { 2364, 2790, spellLevel = 62, maxLevel = 68, },
					[13] = { 2707, 3197, spellLevel = 69, maxLevel = 70, },
		},
		[BS["Rejuvenation"]] = {
					[0] = { School = "Nature", Healing = true, eDot = true, eDuration = 12, sTicks = 3, },
					[7] = { 388, 388, spellLevel = 40, maxLevel = 49, },
					[8] = { 488, 488, spellLevel = 46, maxLevel = 49, },
					[9] = { 608, 608, spellLevel = 52, maxLevel = 55, },
					[10] = { 756, 756, spellLevel = 58, maxLevel = 59, }, --Verify maxlevel
					[11] = { 888, 888, spellLevel = 60, maxLevel = 62, },
					[12] = { 932, 932, spellLevel = 63, maxLevel = 68, },
					[13] = { 1060, 1060, spellLevel = 69, maxLevel = 70, },
		},
		[BS["Regrowth"]] = {
					[0] = { School = "Nature", Healing = true, canCrit = true, castTime = 2, hybridFactor = 0.499, eDuration = 21, sTicks = 3, },
					[4] = { 318, 360, hybridDotDmg = 427, spellLevel = 36, maxLevel = 41, },
					[5] = { 405, 457, hybridDotDmg = 546, spellLevel = 42, maxLevel = 47, },
					[6] = { 646, 724, hybridDotDmg = 686, spellLevel = 48, maxLevel = 53, },
					[8] = { 809, 905, hybridDotDmg = 861, spellLevel = 54, maxLevel = 59, },
					[9] = { 1003, 1119, hybridDotDmg = 1064, spellLevel = 60, maxLevel = 64, },
					[9] = { 1215, 1355, hybridDotDmg = 1274, spellLevel = 65, maxLevel = 70, },
		},
		[BS["Tranquility"]] = {
					[0] = { School = "Nature", Healing = true, castTime = 10, sFactor = 1/3, sHits = 5, },
					[1] = { 94, 94, spellLevel = 30, maxLevel = 39, },
					[2] = { 138, 138, spellLevel = 40, maxLevel = 49, },
					[3] = { 205, 205, spellLevel = 50, maxLevel = 59, },
					[4] = { 294, 294,  spellLevel = 60, maxLevel = 69, },
					[5] = { 407, 407,  spellLevel = 70, maxLevel = 70, },
		},
		[BS["Lifebloom"]] = {
					[0] = { School = "Nature", Healing = true, bonusFactor = 7/15, eDuration = 7, sTicks = 1, },
					[1] = { 600, 600, hybridDotDmg = 273, spellLevel = 64, maxLevel = 70, },					
		},		
	},
	talentInfo = {
		["Starlight Wrath"] = { Effect = 1, Spells = { "Wrath", "Starfire" }, ModType = "CastTime", },
		["Focused Starlight"] = { Effect = 2, Spells = { "Wrath", "Starfire" }, ModType = "Crit", },
		["Improved Moonfire"] = { Effect = 2, Spells = { "Moonfire" }, ModType = "Crit", Effect2 = 0.02, Spells2 = { "Moonfire" }, },
		["Vengeance"] = { Effect = 0.1, Spells = { "Starfire", "Moonfire", "Wrath" }, ModType="CritMultiplier", },
		["Moonfury"] = { Effect = 0.02, Spells = { "Starfire", "Moonfire", "Wrath" }, },
		["Balance of Power"] = { Effect = 2, Spells = { "All" }, ModType = "Hit" },
		["Wrath of Cenarius"] = { Effect = 0.04, Spells = { "Starfire", }, ModType = "SpellDamage", Effect2 = 0.02, Spells2 = { "Wrath", }, ModType2 = "SpellDamage", },
		["Naturalist"] = { Effect = 1, Spells = { "Healing Touch" }, ModType = "CastTime", },
		["Gift of Nature"] = { Effect = 0.02, Spells = { "Rejuvenation", "Regrowth", "Healing Touch", "Tranquility", "Lifebloom" }, },
		["Improved Rejuvenation"] = { Effect = 0.05, Spells = { "Rejuvenation" }, },
		["Improved Regrowth"] = { Effect = 10, Spells = { "Regrowth" }, ModType = "Crit" },
		["Empowered Healing Touch"] = { Effect = 0.1, Spells = { "Healing Touch" }, ModType = "SpellDamage", },
		["Natural Perfection"] = { Effect = 1, Spells = { "Wrath", "Starfire" }, ModType = "Crit", },
		["Empowered Rejuvenation"] = { Effect = 0.04, Spells = { "Rejuvenation" }, ModType = "SpellDamage", Effect2 = 0.04, Spells2 = { "Regrowth" }, ModType2 = "DotSpellDamage", },
	},
	
}